;*******************************************************************
;* AM TX PWM Audio Processor                     * 05.09 * V. 1.0a *
;*******************************************************************

        LIST P=18F1220
        include <p18f1220.inc>

        __CONFIG _CONFIG1H, B'00000110'
        __CONFIG _CONFIG2L, B'00001010'
        __CONFIG _CONFIG2H, B'00001111'
        __CONFIG _CONFIG3H, B'00000000'
        __CONFIG _CONFIG4L, B'10000001'
        __CONFIG _CONFIG5L, B'00000011'
        __CONFIG _CONFIG5H, B'11000000'
        __CONFIG _CONFIG6L, B'00000000'
        __CONFIG _CONFIG6H, B'10000000'
        __CONFIG _CONFIG7L, B'00000011'
        __CONFIG _CONFIG7H, B'01000000'


SMPCNT	EQU	0x00
INDBTS	EQU	0x01
CLKCNT	EQU	0x02
DCLEVL	EQU	0x04
DCLEVH	EQU	0x05
DCBUFL	EQU	0x06
DCBUFH	EQU	0x07
DCBUFU	EQU	0x08
DCBUFT	EQU	0x09
DCCNTL	EQU	0x0A
DCCNTH	EQU	0x0B
GAIN	EQU	0x0C
LLIMCNT	EQU	0x0D
LGATCNT	EQU	0x0E
LCLPCNT	EQU	0x0F

DLA1L	EQU	0x10
DLA1H	EQU	0x11
DLA2L	EQU	0x12
DLA2H	EQU	0x13
DLA3L	EQU	0x14
DLA3H	EQU	0x15
DLA4L	EQU	0x16
DLA4H	EQU	0x17
DLA5L	EQU	0x18
DLA5H	EQU	0x19
DLA6L	EQU	0x1A
DLA6H	EQU	0x1B

DLB1	EQU	0x20
DLB2	EQU	0x21
DLB3	EQU	0x22

SAMPL	EQU	0x23
SAMPH	EQU	0x24
SAMP2L	EQU	0x25
SAMP2H	EQU	0x26

W_TEMP	EQU	0x30
S_TEMP	EQU	0x31

DLC1L	EQU	0x38
DLC1H	EQU	0x39
CSAMPL	EQU	0x3A
CSAMPH	EQU	0x3B
CCNT	EQU	0x3C
LEDCNT	EQU	0x3D
LEDCNTL	EQU	0x3E
ATCKCNT	EQU	0x3F

CLK	EQU	4
LLIM	EQU	5
LCLP	EQU	6
LGAT	EQU	7

JPCLIP	EQU	0
JPKOMP	EQU	1

#DEFINE	KHZ	INDBTS,0


;*********************************
;********* START *****************
;*********************************

        ORG     0x0000          ;Reset
	GOTO	MAIN

        ORG     0x0008          ;High priority interrupt

;------------- Ref. output 1 kHz ------------------------

	MOVLW	0xEC
	MOVWF	TMR0H
	MOVLW	0x80
	MOVWF	TMR0L
	BCF	INTCON,TMR0IF
	BTG	LATB,CLK
	RETFIE	1

        ORG     0x0018          ;Low priority interrupt

	MOVWF	W_TEMP
	MOVFF	STATUS, S_TEMP
	BCF	PIR1,TMR2IF

;------------- PWM 1/3 ------------------------
				;sending to PWM (PWM is 0-319)
	RRCF	SAMP2H,F
	RRCF	SAMP2L,F
	BCF	CCP1CON,4
	BTFSC	STATUS,C
	BSF	CCP1CON,4

	RRCF	SAMP2H,F
	RRCF	SAMP2L,W
	BCF	CCP1CON,5
	BTFSC	STATUS,C
	BSF	CCP1CON,5

	MOVWF	CCPR1L

;------------- A/D ------------------------
				;Limit LED
	TSTFSZ	ADRESL
	BRA	ADINT1
	TSTFSZ	ADRESH
	BRA	ADINT2
	CLRF	LLIMCNT
	BRA	ADINT2
ADINT1
	INCFSZ	ADRESL,W
	BRA	ADINT2
	MOVLW	D'3'
	CPFSEQ	ADRESH
	BRA	ADINT2
	CLRF	LLIMCNT
ADINT2
	MOVLW	D'2'		;DC removal
	SUBWF	ADRESH,F
				;more trebles + low pass
	CLRF	SAMP2L
	CLRF	SAMP2H
	MOVF	DLA6L,W		;-1
	SUBWF	SAMP2L,F
	MOVF	DLA6H,W
	SUBWFB	SAMP2H,F
	
	MOVF	DLA5L,W		;-1
	MOVWF	DLA6L
	SUBWF	SAMP2L,F
	MOVF	DLA5H,W
	MOVWF	DLA6H
	SUBWFB	SAMP2H,F
	
	MOVF	DLA4L,W		;2
	MOVWF	DLA5L
	ADDWF	SAMP2L,F
	MOVF	DLA4H,W
	MOVWF	DLA5H
	ADDWFC	SAMP2H,F
	MOVF	DLA4L,W		
	ADDWF	SAMP2L,F
	MOVF	DLA4H,W
	ADDWFC	SAMP2H,F
	
	MOVF	DLA3L,W		;3
	MOVWF	DLA4L
	ADDWF	SAMP2L,F
	MOVF	DLA3H,W
	MOVWF	DLA4H
	ADDWFC	SAMP2H,F
	MOVF	DLA3L,W		
	ADDWF	SAMP2L,F
	MOVF	DLA3H,W
	ADDWFC	SAMP2H,F
	MOVF	DLA3L,W		
	ADDWF	SAMP2L,F
	MOVF	DLA3H,W
	ADDWFC	SAMP2H,F
	
	MOVF	DLA2L,W		;2
	MOVWF	DLA3L
	ADDWF	SAMP2L,F
	MOVF	DLA2H,W
	MOVWF	DLA3H
	ADDWFC	SAMP2H,F
	MOVF	DLA2L,W		
	ADDWF	SAMP2L,F
	MOVF	DLA2H,W
	ADDWFC	SAMP2H,F
	
	MOVF	DLA1L,W		;-1
	MOVWF	DLA2L
	SUBWF	SAMP2L,F
	MOVF	DLA1H,W
	MOVWF	DLA2H
	SUBWFB	SAMP2H,F
	
	MOVF	ADRESL,W	;-1
	MOVWF	DLA1L
	SUBWF	SAMP2L,F
	MOVF	ADRESH,W
	MOVWF	DLA1H
	SUBWFB	SAMP2H,F	;(85 instr. from the interrupt beginning)

	BSF	ADCON0,1  	;start new sample
PWMAW
	BTFSS	PIR1,TMR2IF	
	BRA	PWMAW
	BCF	PIR1,TMR2IF

				;gain (ARG1=SAMP2, ARG2=GAIN, RES=SAMP (RES1=SAMPL,RES2=SAMPH))
	CLRF	SAMPH
	MOVF	SAMP2L, W
	MULWF	GAIN
	MOVFF	PRODH, SAMPL
	MOVF	SAMP2H, W
	MULWF	GAIN
	MOVF	PRODL, W
	ADDWF	SAMPL, F
	MOVF	PRODH, W
	ADDWFC	SAMPH, F
	MOVF	GAIN, W
	BTFSC	SAMP2H, 7 	; SAMP2 positive?
	SUBWF	SAMPH,F

				;clipper (output in SAMPL), gain reduction - attack
	MOVF	SAMPH,F
	BZ	OREZEND
	INCF	SAMPH,W
	BZ	OREZEND

	MOVLW	B'01111111'
	MOVWF	SAMPL
	BTFSC	SAMPH,7
	INCF	SAMPL,F

	CLRF	LCLPCNT
	DECFSZ	ATCKCNT,F
	BRA	PWM1

	MOVLW	D'4'		;low clipping
	BTFSS	PORTB,JPCLIP
	MOVLW	D'12'		;high clipping
	MOVWF	ATCKCNT

	CLRF	CCNT		;clear compressor counter to avoid immediate amplification

	DECFSZ	GAIN,F
	BRA	PWM1
	INCF	GAIN,F
	BRA	PWM1
OREZEND
	RRCF	SAMPH,F
	RRCF	SAMPL,F

;------------- PWM 2/3 ------------------------

PWM1				;low pass filter (output in SAMP2H)
	MOVLW	D'40'
	MULWF	DLB3
	BTFSC	DLB3,7
	SUBWF	PRODH,F
	MOVFF	PRODH,SAMP2H
	MOVFF	PRODL,SAMP2L
	MOVFF	DLB2,DLB3

	MOVLW	D'87'
	MULWF	DLB2
	BTFSC	DLB2,7
	SUBWF	PRODH,F
	MOVF	PRODL,W
	ADDWF	SAMP2L
	MOVF	PRODH,W
	ADDWFC	SAMP2H
	MOVFF	DLB1,DLB2

	MOVLW	D'87'
	MULWF	DLB1
	BTFSC	DLB1,7
	SUBWF	PRODH,F
	MOVF	PRODL,W
	ADDWF	SAMP2L
	MOVF	PRODH,W
	ADDWFC	SAMP2H
	MOVFF	SAMPL,DLB1

	MOVLW	D'41'
	MULWF	SAMPL
	BTFSC	SAMPL,7
	SUBWF	PRODH,F
	MOVF	PRODL,W
	ADDWF	SAMP2L
	MOVF	PRODH,W
	ADDWFC	SAMP2H
				;-128-127 => 0-255
	MOVLW	D'128'
	ADDWF	SAMP2H,W
	MOVWF	SAMP2L
	CLRF	SAMP2H
				;constant
	MOVLW	D'60'
	ADDWF	SAMP2L,F
	CLRF	WREG
	ADDWFC	SAMP2H,F
				;sending to PWM (PWM is 0-319)
PWM1W
	BTFSS	PIR1,TMR2IF	
	BRA	PWM1W
	BCF	PIR1,TMR2IF

	RRCF	SAMP2H,F
	RRCF	SAMP2L,F
	BCF	CCP1CON,4
	BTFSC	STATUS,C
	BSF	CCP1CON,4

	RRCF	SAMP2H,F
	RRCF	SAMP2L,W
	BCF	CCP1CON,5
	BTFSC	STATUS,C
	BSF	CCP1CON,5

	MOVWF	CCPR1L		;no more than 240 instructions until here from the interrupt beginning!

;------------- PWM 3/3 ------------------------

PWM2				;low pass filter (output in SAMP2H)
	MOVLW	D'40'
	MULWF	DLB3
	BTFSC	DLB3,7
	SUBWF	PRODH,F
	MOVFF	PRODH,SAMP2H
	MOVFF	PRODL,SAMP2L
	MOVFF	DLB2,DLB3

	MOVLW	D'87'
	MULWF	DLB2
	BTFSC	DLB2,7
	SUBWF	PRODH,F
	MOVF	PRODL,W
	ADDWF	SAMP2L
	MOVF	PRODH,W
	ADDWFC	SAMP2H
	MOVFF	DLB1,DLB2

	MOVLW	D'87'
	MULWF	DLB1
	BTFSC	DLB1,7
	SUBWF	PRODH,F
	MOVF	PRODL,W
	ADDWF	SAMP2L
	MOVF	PRODH,W
	ADDWFC	SAMP2H
	MOVFF	SAMPL,DLB1

	MOVLW	D'41'
	MULWF	SAMPL
	BTFSC	SAMPL,7
	SUBWF	PRODH,F
	MOVF	PRODL,W
	ADDWF	SAMP2L
	MOVF	PRODH,W
	ADDWFC	SAMP2H
				;-128-127 => 0-255
	MOVLW	D'128'
	ADDWF	SAMP2H,W
	MOVWF	SAMP2L
	CLRF	SAMP2H
				;constant
	MOVLW	D'60'
	ADDWF	SAMP2L,F
	CLRF	WREG
	ADDWFC	SAMP2H,F

;------------- RELEASE ------------------------

	INCF	CLKCNT,F
	MOVLW	D'90'
	SUBWF	CLKCNT,W
	BTFSS	STATUS,Z
	BRA	RLSEND

	CLRF	CLKCNT
	BTFSC	PORTB,JPKOMP
	BRA	LOWKOMP

	INCF	CCNT,F
	BTFSS	CCNT,2		;<- release time of the compressor - high compression
	BRA	RLSEND
	CLRF	CCNT
	INCF	GAIN,F
	BRA	RLSEND
LOWKOMP
	INCF	CCNT,F
	BTFSS	CCNT,4		;<- release time of the compressor - low compression
	BRA	RLSEND
	CLRF	CCNT
	INCF	GAIN,F
RLSEND
	INCF	GAIN,W
	BZ	RLSEND1
	TSTFSZ	GAIN
	BRA	RLSEND2
RLSEND1
	CLRF	LGATCNT
	SETF	GAIN
RLSEND2

	MOVF	W_TEMP, W
	MOVFF	S_TEMP,STATUS

PWMBW
	BTFSS	PIR1,TMR2IF	
	BRA	PWMBW
	BCF	PIR1,TMR2IF

	RETFIE	0		;no more than 320 instructions until here from the interrupt beginning!

;********* INITIALIZATION *******************************************

MAIN
	MOVLW	D'16'
	MOVWF	GAIN

	MOVLW	B'10001000'	;TIMER0 - output 1 kHz
	MOVWF	T0CON

	MOVLW   B'11111111'     ;I/O
        MOVWF   TRISA,0
        MOVLW   B'00000111'
       	MOVWF   TRISB,0
	BCF	INTCON2,7

	MOVLW	B'01000001'	;A/D
	MOVWF	ADCON0
	MOVLW	B'01111110'
	MOVWF	ADCON1
	MOVLW	B'10000110'
	MOVWF	ADCON2

        MOVLW   B'00001100'	;PWM
        MOVWF   CCP1CON,0
	MOVLW	B'00000100'
	MOVWF	T2CON
	MOVLW	D'79'
	MOVWF	PR2

	BSF	RCON,IPEN
	CLRF	IPR1
        MOVLW   B'00000010'	;INT
        MOVWF   PIE1,0
        MOVLW   B'11100000'
        MOVWF   INTCON,0

;********* POWER UP LED EFFECTS *******************************

	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BSF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BCF	LATB,LGAT
	BSF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BSF	LATB,LLIM
	RCALL	CEKEJ

	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BSF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BCF	LATB,LGAT
	BSF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BSF	LATB,LLIM
	RCALL	CEKEJ

	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BSF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BCF	LATB,LGAT
	BSF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ
	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BSF	LATB,LLIM
	RCALL	CEKEJ

	BCF	LATB,LGAT
	BCF	LATB,LCLP
	BCF	LATB,LLIM
	RCALL	CEKEJ

	SETF	LLIMCNT
	SETF	LGATCNT
	SETF	LCLPCNT

	BRA	LOOP

CEKEJ	MOVLW	D'190'
	MOVWF	LEDCNT
CEKEJ2	CLRWDT
	RCALL	CEKEJL
	DECFSZ	LEDCNT,F
	BRA	CEKEJ2
	RETURN

CEKEJL	MOVLW	D'255'
	MOVWF	LEDCNTL
CEKEJ3	CLRWDT
	DECFSZ	LEDCNTL,F
	BRA	CEKEJ3
	RETURN

;********* LOOP *******************************************

LOOP
	CLRWDT
	INCFSZ	LEDCNT,F
	BRA	LOOP

	MOVLW	D'150'
	MOVWF	LEDCNT

	BTFSC	LLIMCNT,7
	BRA	LOOP2
	BSF	LATB,LLIM
	INCF	LLIMCNT,F
LOOP2
	BTFSC	LCLPCNT,7
	BRA	LOOP3
	BSF	LATB,LCLP
	INCF	LCLPCNT,F
LOOP3
	BTFSC	LGATCNT,7
	BRA	LOOP4
	BSF	LATB,LGAT
	INCF	LGATCNT,F
LOOP4
	BTFSC	LGATCNT,7
	BCF	LATB,LGAT
	BTFSC	LCLPCNT,7
	BCF	LATB,LCLP
	BTFSC	LLIMCNT,7
	BCF	LATB,LLIM

	BRA	LOOP

	END
	